Index: drivers/filesystems/btrfs/fileinfo.c
===================================================================
--- drivers/filesystems/btrfs/fileinfo.c	(révision 75772)
+++ drivers/filesystems/btrfs/fileinfo.c	(copie de travail)
@@ -1497,17 +1311,19 @@
     BTRFS_TIME now;
     LIST_ENTRY rollback, *le;
     hardlink* hl;
-    
+    SECURITY_SUBJECT_CONTEXT subjcont;
+    ACCESS_MASK access;
+
     InitializeListHead(&rollback);
-    
+
     TRACE("tfo = %p\n", tfo);
     TRACE("ReplaceIfExists = %u\n", IrpSp->Parameters.SetFile.ReplaceIfExists);
     TRACE("RootDirectory = %p\n", fri->RootDirectory);
     TRACE("FileName = %.*S\n", fri->FileNameLength / sizeof(WCHAR), fri->FileName);
-    
+
     fn = fri->FileName;
     fnlen = fri->FileNameLength / sizeof(WCHAR);
-    
+
     if (!tfo) {
         if (!fileref || !fileref->parent) {
             ERR("no fileref set and no directory given\n");
@@ -1515,13 +1331,13 @@
         }
     } else {
         LONG i;
-        
+
         while (fnlen > 0 && (fri->FileName[fnlen - 1] == '/' || fri->FileName[fnlen - 1] == '\\'))
             fnlen--;
-        
+
         if (fnlen == 0)
             return STATUS_INVALID_PARAMETER;
-        
+
         for (i = fnlen - 1; i >= 0; i--) {
             if (fri->FileName[i] == '\\' || fri->FileName[i] == '/') {
                 fn = &fri->FileName[i+1];
@@ -1530,27 +1346,31 @@
             }
         }
     }
-    
+
     ExAcquireResourceSharedLite(&Vcb->tree_lock, TRUE);
     ExAcquireResourceExclusiveLite(&Vcb->fcb_lock, TRUE);
     ExAcquireResourceExclusiveLite(fcb->Header.Resource, TRUE);
-    
+
     if (fcb->ads) {
-        FIXME("FIXME - renaming streams\n"); // FIXME
-        Status = STATUS_NOT_IMPLEMENTED;
+        // MSDN says that NTFS data streams can be renamed (https://msdn.microsoft.com/en-us/library/windows/hardware/ff540344.aspx),
+        // but if you try it always seems to return STATUS_INVALID_PARAMETER. There is a function in ntfs.sys called NtfsStreamRename,
+        // but it never seems to get invoked... If you know what's going on here, I'd appreciate it if you let me know.
+        Status = STATUS_INVALID_PARAMETER;
         goto end;
     }
-    
+
     fnus.Buffer = fn;
-    fnus.Length = fnus.MaximumLength = fnlen * sizeof(WCHAR);
-    
+    fnus.Length = fnus.MaximumLength = (UINT16)(fnlen * sizeof(WCHAR));
+
     TRACE("fnus = %.*S\n", fnus.Length / sizeof(WCHAR), fnus.Buffer);
-    
+
+    origutf8len = fileref->dc->utf8.Length;
+
     Status = RtlUnicodeToUTF8N(NULL, 0, &utf8len, fn, (ULONG)fnlen * sizeof(WCHAR));
     if (!NT_SUCCESS(Status))
         goto end;
-    
-    utf8.MaximumLength = utf8.Length = utf8len;
+
+    utf8.MaximumLength = utf8.Length = (UINT16)utf8len;
     utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.MaximumLength, ALLOC_TAG);
     if (!utf8.Buffer) {
         ERR("out of memory\n");
@@ -1557,14 +1377,14 @@
         Status = STATUS_INSUFFICIENT_RESOURCES;
         goto end;
     }
-    
+
     Status = RtlUnicodeToUTF8N(utf8.Buffer, utf8len, &utf8len, fn, (ULONG)fnlen * sizeof(WCHAR));
     if (!NT_SUCCESS(Status))
         goto end;
-    
+
     if (tfo && tfo->FsContext2) {
         struct _ccb* relatedccb = tfo->FsContext2;
-        
+
         related = relatedccb->fileref;
         increase_fileref_refcount(related);
     } else if (fnus.Length >= sizeof(WCHAR) && fnus.Buffer[0] != '\\') {
@@ -1576,7 +1396,7 @@
 
     if (NT_SUCCESS(Status)) {
         TRACE("destination file %S already exists\n", file_desc_fileref(oldfileref));
-        
+
         if (fileref != oldfileref && !oldfileref->deleted) {
             if (!IrpSp->Parameters.SetFile.ReplaceIfExists) {
                 Status = STATUS_OBJECT_NAME_COLLISION;
@@ -1586,7 +1406,7 @@
                 Status = STATUS_ACCESS_DENIED;
                 goto end;
             }
-            
+
             if (oldfileref->fcb->type == BTRFS_TYPE_DIRECTORY) {
                 WARN("trying to overwrite directory\n");
                 Status = STATUS_ACCESS_DENIED;
@@ -1593,13 +1413,13 @@
                 goto end;
             }
         }
-        
+
         if (fileref == oldfileref || oldfileref->deleted) {
-            free_fileref(oldfileref);
+            free_fileref(Vcb, oldfileref);
             oldfileref = NULL;
         }
     }
-    
+
     if (!related) {
         Status = open_fileref(Vcb, &related, &fnus, NULL, TRUE, NULL, NULL, PagedPool, ccb->case_sensitive, Irp);
 
@@ -1608,28 +1428,41 @@
             goto end;
         }
     }
-    
+
+    if (related->fcb == Vcb->dummy_fcb) {
+        Status = STATUS_ACCESS_DENIED;
+        goto end;
+    }
+
+    SeCaptureSubjectContext(&subjcont);
+
+    if (!SeAccessCheck(related->fcb->sd, &subjcont, FALSE, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_ADD_SUBDIRECTORY : FILE_ADD_FILE, 0, NULL,
+        IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
+        SeReleaseSubjectContext(&subjcont);
+        TRACE("SeAccessCheck failed, returning %08x\n", Status);
+        goto end;
+    }
+
+    SeReleaseSubjectContext(&subjcont);
+
     if (has_open_children(fileref)) {
         WARN("trying to rename file with open children\n");
         Status = STATUS_ACCESS_DENIED;
         goto end;
     }
-    
+
     if (oldfileref) {
-        ACCESS_MASK access;
-        SECURITY_SUBJECT_CONTEXT subjcont;
-        
         SeCaptureSubjectContext(&subjcont);
 
         if (!SeAccessCheck(oldfileref->fcb->sd, &subjcont, FALSE, DELETE, 0, NULL,
                            IoGetFileObjectGenericMapping(), Irp->RequestorMode, &access, &Status)) {
             SeReleaseSubjectContext(&subjcont);
-            WARN("SeAccessCheck failed, returning %08x\n", Status);
+            TRACE("SeAccessCheck failed, returning %08x\n", Status);
             goto end;
         }
 
         SeReleaseSubjectContext(&subjcont);
-        
+
         Status = delete_fileref(oldfileref, NULL, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("delete_fileref returned %08x\n", Status);
@@ -1636,132 +1469,154 @@
             goto end;
         }
     }
-    
-    if (fileref->parent->fcb->subvol != related->fcb->subvol && fileref->fcb->subvol == fileref->parent->fcb->subvol) {
-        Status = move_across_subvols(fileref, related, &utf8, &fnus, Irp, &rollback);
+
+    if (fileref->parent->fcb->subvol != related->fcb->subvol && (fileref->fcb->subvol == fileref->parent->fcb->subvol || fileref->fcb == Vcb->dummy_fcb)) {
+        Status = move_across_subvols(fileref, ccb, related, &utf8, &fnus, Irp, &rollback);
         if (!NT_SUCCESS(Status)) {
             ERR("move_across_subvols returned %08x\n", Status);
         }
         goto end;
     }
-    
+
     if (related == fileref->parent) { // keeping file in same directory
-        UNICODE_STRING fnus2, oldfn, newfn;
+        UNICODE_STRING oldfn, newfn;
         USHORT name_offset;
-        ULONG oldutf8len;
-        
-        fnus2.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-        if (!fnus2.Buffer) {
+        ULONG reqlen, oldutf8len;
+
+        oldfn.Length = oldfn.MaximumLength = 0;
+
+        Status = fileref_get_filename(fileref, &oldfn, &name_offset, &reqlen);
+        if (Status != STATUS_BUFFER_OVERFLOW) {
+            ERR("fileref_get_filename returned %08x\n", Status);
+            goto end;
+        }
+
+        oldfn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+        if (!oldfn.Buffer) {
             ERR("out of memory\n");
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        Status = fileref_get_filename(fileref, &oldfn, &name_offset);
+
+        oldfn.MaximumLength = (UINT16)reqlen;
+
+        Status = fileref_get_filename(fileref, &oldfn, &name_offset, &reqlen);
         if (!NT_SUCCESS(Status)) {
             ERR("fileref_get_filename returned %08x\n", Status);
-            goto end;
-        }
-        
-        fnus2.Length = fnus2.MaximumLength = fnus.Length;
-        RtlCopyMemory(fnus2.Buffer, fnus.Buffer, fnus.Length);
-        
-        oldutf8len = fileref->utf8.Length;
-        
-        if (!fileref->created && !fileref->oldutf8.Buffer)
-            fileref->oldutf8 = fileref->utf8;
-        else
-            ExFreePool(fileref->utf8.Buffer);
-        
-        TRACE("renaming %.*S to %.*S\n", fileref->filepart.Length / sizeof(WCHAR), fileref->filepart.Buffer, fnus2.Length / sizeof(WCHAR), fnus.Buffer);
-        
-        fileref->utf8 = utf8;
-        fileref->filepart = fnus2;
-        
-        Status = fileref_get_filename(fileref, &newfn, &name_offset);
-        if (!NT_SUCCESS(Status)) {
-            ERR("fileref_get_filename returned %08x\n", Status);
             ExFreePool(oldfn.Buffer);
             goto end;
         }
-        
-        if (fileref->filepart_uc.Buffer)
-            ExFreePool(fileref->filepart_uc.Buffer);
-        
-        Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
-        if (!NT_SUCCESS(Status)) {
-            ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-            ExFreePool(oldfn.Buffer);
-            ExFreePool(newfn.Buffer);
-            goto end;
+
+        oldutf8len = fileref->dc->utf8.Length;
+
+        if (!fileref->created && !fileref->oldutf8.Buffer) {
+            fileref->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->dc->utf8.Length, ALLOC_TAG);
+            if (!fileref->oldutf8.Buffer) {
+                ERR("out of memory\n");
+                Status = STATUS_INSUFFICIENT_RESOURCES;
+                goto end;
+            }
+
+            fileref->oldutf8.Length = fileref->oldutf8.MaximumLength = fileref->dc->utf8.Length;
+            RtlCopyMemory(fileref->oldutf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
         }
-        
+
+        TRACE("renaming %.*S to %.*S\n", fileref->dc->name.Length / sizeof(WCHAR), fileref->dc->name.Buffer, fnus.Length / sizeof(WCHAR), fnus.Buffer);
+
         mark_fileref_dirty(fileref);
-        
+
         if (fileref->dc) {
             ExAcquireResourceExclusiveLite(&fileref->parent->fcb->nonpaged->dir_children_lock, TRUE);
-            
+
             ExFreePool(fileref->dc->utf8.Buffer);
             ExFreePool(fileref->dc->name.Buffer);
             ExFreePool(fileref->dc->name_uc.Buffer);
-            
+
             fileref->dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.Length, ALLOC_TAG);
             if (!fileref->dc->utf8.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
                 goto end;
             }
-            
-            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart.Length, ALLOC_TAG);
+
+            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
+            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
+
+            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
             if (!fileref->dc->name.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
                 goto end;
             }
-            
-            fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart_uc.Length, ALLOC_TAG);
-            if (!fileref->dc->name_uc.Buffer) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
+
+            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fnus.Length;
+            RtlCopyMemory(fileref->dc->name.Buffer, fnus.Buffer, fnus.Length);
+
+            Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
+                ExFreePool(oldfn.Buffer);
                 goto end;
             }
-            
-            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
-            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
-            
-            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fileref->filepart.Length;
-            RtlCopyMemory(fileref->dc->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-            
-            fileref->dc->name_uc.Length = fileref->dc->name_uc.MaximumLength = fileref->filepart_uc.Length;
-            RtlCopyMemory(fileref->dc->name_uc.Buffer, fileref->filepart_uc.Buffer, fileref->filepart_uc.Length);
-            
+
             remove_dir_child_from_hash_lists(fileref->parent->fcb, fileref->dc);
-            
+
             fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name.Buffer, fileref->dc->name.Length);
             fileref->dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name_uc.Buffer, fileref->dc->name_uc.Length);
-            
+
             insert_dir_child_into_hash_lists(fileref->parent->fcb, fileref->dc);
-            
+
             ExReleaseResourceLite(&fileref->parent->fcb->nonpaged->dir_children_lock);
         }
-        
+
+        newfn.Length = newfn.MaximumLength = 0;
+
+        Status = fileref_get_filename(fileref, &newfn, &name_offset, &reqlen);
+        if (Status != STATUS_BUFFER_OVERFLOW) {
+            ERR("fileref_get_filename returned %08x\n", Status);
+            ExFreePool(oldfn.Buffer);
+            goto end;
+        }
+
+        newfn.Buffer = ExAllocatePoolWithTag(PagedPool, reqlen, ALLOC_TAG);
+        if (!newfn.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            ExFreePool(oldfn.Buffer);
+            goto end;
+        }
+
+        newfn.MaximumLength = (UINT16)reqlen;
+
+        Status = fileref_get_filename(fileref, &newfn, &name_offset, &reqlen);
+        if (!NT_SUCCESS(Status)) {
+            ERR("fileref_get_filename returned %08x\n", Status);
+            ExFreePool(oldfn.Buffer);
+            ExFreePool(newfn.Buffer);
+            goto end;
+        }
+
         KeQuerySystemTime(&time);
         win_time_to_unix(time, &now);
-        
-        fcb->inode_item.transid = Vcb->superblock.generation;
-        fcb->inode_item.sequence++;
-        
-        if (!ccb->user_set_change_time)
-            fcb->inode_item.st_ctime = now;
-        
-        fcb->inode_item_changed = TRUE;
-        mark_fcb_dirty(fcb);
-        
+
+        if (fcb != Vcb->dummy_fcb && (fileref->parent->fcb->subvol == fcb->subvol || !is_subvol_readonly(fcb->subvol, Irp))) {
+            fcb->inode_item.transid = Vcb->superblock.generation;
+            fcb->inode_item.sequence++;
+
+            if (!ccb->user_set_change_time)
+                fcb->inode_item.st_ctime = now;
+
+            fcb->inode_item_changed = TRUE;
+            mark_fcb_dirty(fcb);
+        }
+
         // update parent's INODE_ITEM
-        
+
         related->fcb->inode_item.transid = Vcb->superblock.generation;
         TRACE("related->fcb->inode_item.st_size (inode %llx) was %llx\n", related->fcb->inode, related->fcb->inode_item.st_size);
         related->fcb->inode_item.st_size = related->fcb->inode_item.st_size + (2 * utf8.Length) - (2* oldutf8len);
@@ -1769,70 +1624,62 @@
         related->fcb->inode_item.sequence++;
         related->fcb->inode_item.st_ctime = now;
         related->fcb->inode_item.st_mtime = now;
-        
+
         related->fcb->inode_item_changed = TRUE;
         mark_fcb_dirty(related->fcb);
-        send_notification_fileref(related, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-        
+        send_notification_fileref(related, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
         FsRtlNotifyFilterReportChange(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, (PSTRING)&oldfn, name_offset, NULL, NULL,
                                       fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_RENAMED_OLD_NAME, NULL, NULL);
         FsRtlNotifyFilterReportChange(fcb->Vcb->NotifySync, &fcb->Vcb->DirNotifyList, (PSTRING)&newfn, name_offset, NULL, NULL,
                                       fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_RENAMED_NEW_NAME, NULL, NULL);
-        
+
         ExFreePool(oldfn.Buffer);
         ExFreePool(newfn.Buffer);
-        
+
         Status = STATUS_SUCCESS;
         goto end;
     }
-    
+
     // We move files by moving the existing fileref to the new directory, and
     // replacing it with a dummy fileref with the same original values, but marked as deleted.
-    
-    fr2 = create_fileref();
-    
+
+    send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED, NULL);
+
+    fr2 = create_fileref(Vcb);
+
     fr2->fcb = fileref->fcb;
     fr2->fcb->refcount++;
-    
-    fr2->filepart = fileref->filepart;
-    fr2->filepart_uc = fileref->filepart_uc;
-    fr2->utf8 = fileref->utf8;
+
     fr2->oldutf8 = fileref->oldutf8;
-    fr2->index = fileref->index;
+    fr2->oldindex = fileref->dc->index;
     fr2->delete_on_close = fileref->delete_on_close;
     fr2->deleted = TRUE;
     fr2->created = fileref->created;
     fr2->parent = fileref->parent;
     fr2->dc = NULL;
-    
+
+    if (!fr2->oldutf8.Buffer) {
+        fr2->oldutf8.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->dc->utf8.Length, ALLOC_TAG);
+        if (!fr2->oldutf8.Buffer) {
+            ERR("out of memory\n");
+            Status = STATUS_INSUFFICIENT_RESOURCES;
+            goto end;
+        }
+
+        RtlCopyMemory(fr2->oldutf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+
+        fr2->oldutf8.Length = fr2->oldutf8.MaximumLength = fileref->dc->utf8.Length;
+    }
+
     if (fr2->fcb->type == BTRFS_TYPE_DIRECTORY)
         fr2->fcb->fileref = fr2;
 
-    Status = fcb_get_last_dir_index(related->fcb, &index, Irp);
-    if (!NT_SUCCESS(Status)) {
-        ERR("fcb_get_last_dir_index returned %08x\n", Status);
-        goto end;
-    }
-    
-    fileref->filepart.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
-    if (!fileref->filepart.Buffer) {
-        ERR("out of memory\n");
-        Status = STATUS_INSUFFICIENT_RESOURCES;
-        goto end;
-    }
-    
-    fileref->filepart.Length = fileref->filepart.MaximumLength = fnus.Length;
-    RtlCopyMemory(fileref->filepart.Buffer, fnus.Buffer, fnus.Length);
-    
-    Status = RtlUpcaseUnicodeString(&fileref->filepart_uc, &fileref->filepart, TRUE);
-    if (!NT_SUCCESS(Status)) {
-        ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
-        goto end;
-    }
-    
-    fileref->utf8 = utf8;
+    if (fileref->fcb->inode == SUBVOL_ROOT_INODE)
+        fileref->fcb->subvol->parent = related->fcb->subvol->id;
+
+    fileref->oldutf8.Length = fileref->oldutf8.MaximumLength = 0;
     fileref->oldutf8.Buffer = NULL;
-    fileref->index = index;
     fileref->deleted = FALSE;
     fileref->created = TRUE;
     fileref->parent = related;
@@ -1841,12 +1688,10 @@
     InsertHeadList(&fileref->list_entry, &fr2->list_entry);
     RemoveEntryList(&fileref->list_entry);
     ExReleaseResourceLite(&fileref->parent->nonpaged->children_lock);
-    
-    insert_fileref_child(related, fileref, TRUE);
-    
+
     mark_fileref_dirty(fr2);
     mark_fileref_dirty(fileref);
-    
+
     if (fileref->dc) {
         // remove from old parent
         ExAcquireResourceExclusiveLite(&fr2->parent->fcb->nonpaged->dir_children_lock, TRUE);
@@ -1853,14 +1698,14 @@
         RemoveEntryList(&fileref->dc->list_entry_index);
         remove_dir_child_from_hash_lists(fr2->parent->fcb, fileref->dc);
         ExReleaseResourceLite(&fr2->parent->fcb->nonpaged->dir_children_lock);
-        
-        if (fileref->utf8.Length != fr2->utf8.Length || RtlCompareMemory(fileref->utf8.Buffer, fr2->utf8.Buffer, fr2->utf8.Length) != fr2->utf8.Length) {
+
+        if (fileref->dc->utf8.Length != utf8.Length || RtlCompareMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length) != utf8.Length) {
             // handle changed name
-            
+
             ExFreePool(fileref->dc->utf8.Buffer);
             ExFreePool(fileref->dc->name.Buffer);
             ExFreePool(fileref->dc->name_uc.Buffer);
-            
+
             fileref->dc->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, utf8.Length, ALLOC_TAG);
             if (!fileref->dc->utf8.Buffer) {
                 ERR("out of memory\n");
@@ -1867,44 +1712,53 @@
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
-            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart.Length, ALLOC_TAG);
+
+            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
+            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
+
+            fileref->dc->name.Buffer = ExAllocatePoolWithTag(PagedPool, fnus.Length, ALLOC_TAG);
             if (!fileref->dc->name.Buffer) {
                 ERR("out of memory\n");
                 Status = STATUS_INSUFFICIENT_RESOURCES;
                 goto end;
             }
-            
-            fileref->dc->name_uc.Buffer = ExAllocatePoolWithTag(PagedPool, fileref->filepart_uc.Length, ALLOC_TAG);
-            if (!fileref->dc->name_uc.Buffer) {
-                ERR("out of memory\n");
-                Status = STATUS_INSUFFICIENT_RESOURCES;
+
+            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fnus.Length;
+            RtlCopyMemory(fileref->dc->name.Buffer, fnus.Buffer, fnus.Length);
+
+            Status = RtlUpcaseUnicodeString(&fileref->dc->name_uc, &fileref->dc->name, TRUE);
+            if (!NT_SUCCESS(Status)) {
+                ERR("RtlUpcaseUnicodeString returned %08x\n", Status);
                 goto end;
             }
-            
-            fileref->dc->utf8.Length = fileref->dc->utf8.MaximumLength = utf8.Length;
-            RtlCopyMemory(fileref->dc->utf8.Buffer, utf8.Buffer, utf8.Length);
-            
-            fileref->dc->name.Length = fileref->dc->name.MaximumLength = fileref->filepart.Length;
-            RtlCopyMemory(fileref->dc->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-            
-            fileref->dc->name_uc.Length = fileref->dc->name_uc.MaximumLength = fileref->filepart_uc.Length;
-            RtlCopyMemory(fileref->dc->name_uc.Buffer, fileref->filepart_uc.Buffer, fileref->filepart_uc.Length);
-            
+
             fileref->dc->hash = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name.Buffer, fileref->dc->name.Length);
             fileref->dc->hash_uc = calc_crc32c(0xffffffff, (UINT8*)fileref->dc->name_uc.Buffer, fileref->dc->name_uc.Length);
         }
-        
+
         // add to new parent
         ExAcquireResourceExclusiveLite(&related->fcb->nonpaged->dir_children_lock, TRUE);
+
+        if (IsListEmpty(&related->fcb->dir_children_index))
+            fileref->dc->index = 2;
+        else {
+            dir_child* dc2 = CONTAINING_RECORD(related->fcb->dir_children_index.Blink, dir_child, list_entry_index);
+
+            fileref->dc->index = max(2, dc2->index + 1);
+        }
+
         InsertTailList(&related->fcb->dir_children_index, &fileref->dc->list_entry_index);
         insert_dir_child_into_hash_lists(related->fcb, fileref->dc);
         ExReleaseResourceLite(&related->fcb->nonpaged->dir_children_lock);
     }
-    
+
+    ExAcquireResourceExclusiveLite(&related->nonpaged->children_lock, TRUE);
+    InsertTailList(&related->children, &fileref->list_entry);
+    ExReleaseResourceLite(&related->nonpaged->children_lock);
+
     if (fcb->inode_item.st_nlink > 1) {
         // add new hardlink entry to fcb
-        
+
         hl = ExAllocatePoolWithTag(PagedPool, sizeof(hardlink), ALLOC_TAG);
         if (!hl) {
             ERR("out of memory\n");
@@ -1911,13 +1765,13 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
+
         hl->parent = related->fcb->inode;
-        hl->index = index;
-        
-        hl->name.Length = hl->name.MaximumLength = fileref->filepart.Length;
+        hl->index = fileref->dc->index;
+
+        hl->name.Length = hl->name.MaximumLength = fnus.Length;
         hl->name.Buffer = ExAllocatePoolWithTag(PagedPool, hl->name.MaximumLength, ALLOC_TAG);
-        
+
         if (!hl->name.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl);
@@ -1924,12 +1778,12 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        RtlCopyMemory(hl->name.Buffer, fileref->filepart.Buffer, fileref->filepart.Length);
-        
-        hl->utf8.Length = hl->utf8.MaximumLength = fileref->utf8.Length;
+
+        RtlCopyMemory(hl->name.Buffer, fnus.Buffer, fnus.Length);
+
+        hl->utf8.Length = hl->utf8.MaximumLength = fileref->dc->utf8.Length;
         hl->utf8.Buffer = ExAllocatePoolWithTag(PagedPool, hl->utf8.MaximumLength, ALLOC_TAG);
-        
+
         if (!hl->utf8.Buffer) {
             ERR("out of memory\n");
             ExFreePool(hl->name.Buffer);
@@ -1937,50 +1791,52 @@
             Status = STATUS_INSUFFICIENT_RESOURCES;
             goto end;
         }
-        
-        RtlCopyMemory(hl->utf8.Buffer, fileref->utf8.Buffer, fileref->utf8.Length);
-        
+
+        RtlCopyMemory(hl->utf8.Buffer, fileref->dc->utf8.Buffer, fileref->dc->utf8.Length);
+
         InsertTailList(&fcb->hardlinks, &hl->list_entry);
     }
-        
+
     // delete old hardlink entry from fcb
-    
+
     le = fcb->hardlinks.Flink;
     while (le != &fcb->hardlinks) {
         hl = CONTAINING_RECORD(le, hardlink, list_entry);
-        
-        if (hl->parent == fr2->parent->fcb->inode && hl->index == fr2->index) {
+
+        if (hl->parent == fr2->parent->fcb->inode && hl->index == fr2->oldindex) {
             RemoveEntryList(&hl->list_entry);
-            
+
             if (hl->utf8.Buffer)
                 ExFreePool(hl->utf8.Buffer);
-            
+
             if (hl->name.Buffer)
                 ExFreePool(hl->name.Buffer);
-            
+
             ExFreePool(hl);
             break;
         }
-        
+
         le = le->Flink;
     }
 
     // update inode's INODE_ITEM
-    
+
     KeQuerySystemTime(&time);
     win_time_to_unix(time, &now);
-    
-    fcb->inode_item.transid = Vcb->superblock.generation;
-    fcb->inode_item.sequence++;
-    
-    if (!ccb->user_set_change_time)
-        fcb->inode_item.st_ctime = now;
-    
-    fcb->inode_item_changed = TRUE;
-    mark_fcb_dirty(fcb);
-    
+
+    if (fcb != Vcb->dummy_fcb && (fileref->parent->fcb->subvol == fcb->subvol || !is_subvol_readonly(fcb->subvol, Irp))) {
+        fcb->inode_item.transid = Vcb->superblock.generation;
+        fcb->inode_item.sequence++;
+
+        if (!ccb->user_set_change_time)
+            fcb->inode_item.st_ctime = now;
+
+        fcb->inode_item_changed = TRUE;
+        mark_fcb_dirty(fcb);
+    }
+
     // update new parent's INODE_ITEM
-    
+
     related->fcb->inode_item.transid = Vcb->superblock.generation;
     TRACE("related->fcb->inode_item.st_size (inode %llx) was %llx\n", related->fcb->inode, related->fcb->inode_item.st_size);
     related->fcb->inode_item.st_size += 2 * utf8len;
@@ -1988,44 +1844,43 @@
     related->fcb->inode_item.sequence++;
     related->fcb->inode_item.st_ctime = now;
     related->fcb->inode_item.st_mtime = now;
-    
+
     related->fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(related->fcb);
-    
+
     // update old parent's INODE_ITEM
-    
+
     fr2->parent->fcb->inode_item.transid = Vcb->superblock.generation;
     TRACE("fr2->parent->fcb->inode_item.st_size (inode %llx) was %llx\n", fr2->parent->fcb->inode, fr2->parent->fcb->inode_item.st_size);
-    fr2->parent->fcb->inode_item.st_size -= 2 * fr2->utf8.Length;
+    fr2->parent->fcb->inode_item.st_size -= 2 * origutf8len;
     TRACE("fr2->parent->fcb->inode_item.st_size (inode %llx) now %llx\n", fr2->parent->fcb->inode, fr2->parent->fcb->inode_item.st_size);
     fr2->parent->fcb->inode_item.sequence++;
     fr2->parent->fcb->inode_item.st_ctime = now;
     fr2->parent->fcb->inode_item.st_mtime = now;
-    
-    free_fileref(fr2);
-    
+
+    free_fileref(Vcb, fr2);
+
     fr2->parent->fcb->inode_item_changed = TRUE;
     mark_fcb_dirty(fr2->parent->fcb);
-    
-    send_notification_fileref(fr2, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_REMOVED);
-    send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED);
-    send_notification_fileref(related, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
-    send_notification_fileref(fr2->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED);
 
+    send_notification_fileref(fileref, fcb->type == BTRFS_TYPE_DIRECTORY ? FILE_NOTIFY_CHANGE_DIR_NAME : FILE_NOTIFY_CHANGE_FILE_NAME, FILE_ACTION_ADDED, NULL);
+    send_notification_fileref(related, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+    send_notification_fileref(fr2->parent, FILE_NOTIFY_CHANGE_LAST_WRITE, FILE_ACTION_MODIFIED, NULL);
+
     Status = STATUS_SUCCESS;
 
 end:
     if (oldfileref)
-        free_fileref(oldfileref);
-    
+        free_fileref(Vcb, oldfileref);
+
     if (!NT_SUCCESS(Status) && related)
-        free_fileref(related);
-    
+        free_fileref(Vcb, related);
+
     if (!NT_SUCCESS(Status) && fr2)
-        free_fileref(fr2);
-    
+        free_fileref(Vcb, fr2);
+
     if (NT_SUCCESS(Status))
-        clear_rollback(Vcb, &rollback);
+        clear_rollback(&rollback);
     else
         do_rollback(Vcb, &rollback);
 
@@ -2032,28 +1887,27 @@
     ExReleaseResourceLite(fcb->Header.Resource);
     ExReleaseResourceLite(&Vcb->fcb_lock);
     ExReleaseResourceLite(&Vcb->tree_lock);
-    
+
     return Status;
 }
 
-NTSTATUS STDCALL stream_set_end_of_file_information(device_extension* Vcb, UINT64 end, fcb* fcb, file_ref* fileref, PFILE_OBJECT FileObject, BOOL advance_only, LIST_ENTRY* rollback) {
+NTSTATUS stream_set_end_of_file_information(device_extension* Vcb, UINT16 end, fcb* fcb, file_ref* fileref, BOOL advance_only) {
     LARGE_INTEGER time;
     BTRFS_TIME now;
-    CC_FILE_SIZES ccfs;
-    
+
     TRACE("setting new end to %llx bytes (currently %x)\n", end, fcb->adsdata.Length);
-    
+
     if (!fileref || !fileref->parent) {
         ERR("no fileref for stream\n");
         return STATUS_INTERNAL_ERROR;
     }
-    
+
     if (end < fcb->adsdata.Length) {
         if (advance_only)
             return STATUS_SUCCESS;
-        
+
         TRACE("truncating stream to %llx bytes\n", end);
-        
+
         fcb->adsdata.Length = end;
     } else if (end > fcb->adsdata.Length) {
         TRACE("extending stream to %llx bytes\n", end);
